diff -r -c postgresql-8.4.orig/src/backend/postmaster/postmaster.c postgresql-8.4/src/backend/postmaster/postmaster.c
*** postgresql-8.4.orig/src/backend/postmaster/postmaster.c	2008-04-24 13:43:16.000000000 +0200
--- postgresql-8.4/src/backend/postmaster/postmaster.c	2008-04-24 16:58:06.000000000 +0200
***************
*** 2018,2029 ****
  			 */
  			PostmasterStateMachine();
  
- 			/*
- 			 * Terminate backup mode to avoid recovery after a
- 			 * clean fast shutdown.
- 			 */
- 			CancelBackup();
- 
  			break;
  
  		case SIGQUIT:
--- 2018,2023 ----
***************
*** 2699,2704 ****
--- 2693,2704 ----
  		}
  		else
  		{
+ 			/*
+ 			 * Terminate backup mode to avoid recovery after a
+ 			 * clean fast shutdown.
+ 			 */
+ 			CancelBackup();
+ 
  			/* Normal exit from the postmaster is here */
  			ExitPostmaster(0);
  		}
